import { List, Map } from "immutable";
import { StringMap } from "./Support";
import { TypeGraphBuilder } from "./TypeBuilder";
export declare enum PathElementKind {
    Root = 0,
    Definition = 1,
    OneOf = 2,
    AnyOf = 3,
    AllOf = 4,
    Property = 5,
    AdditionalProperty = 6,
    Items = 7,
    Type = 8,
    Object = 9,
    KeyOrIndex = 10,
}
export declare type PathElement = {
    kind: PathElementKind.Root;
} | {
    kind: PathElementKind.Definition;
    name: string;
} | {
    kind: PathElementKind.OneOf;
    index: number;
} | {
    kind: PathElementKind.AnyOf;
    index: number;
} | {
    kind: PathElementKind.AllOf;
    index: number;
} | {
    kind: PathElementKind.Property;
    name: string;
} | {
    kind: PathElementKind.AdditionalProperty;
} | {
    kind: PathElementKind.Items;
} | {
    kind: PathElementKind.Type;
    index: number;
} | {
    kind: PathElementKind.Object;
} | {
    kind: PathElementKind.KeyOrIndex;
    key: string;
};
export declare class Ref {
    readonly path: List<PathElement>;
    constructor(path: List<PathElement>);
    push(pe: PathElement): Ref;
    readonly definitionName: string | undefined;
    toString(): string;
    lookupRef(root: StringMap, localSchema: StringMap, localRef: Ref): [StringMap, Ref];
    readonly immutable: List<any>;
}
export declare const rootRef: Ref;
export declare function addTypesInSchema(typeBuilder: TypeGraphBuilder, rootJson: any, references: Map<string, Ref>): void;
export declare function definitionRefsInSchema(rootJson: any): Map<string, Ref>;
